/**
 * @file artis/kernel/Simulator.hpp
 * @author See the AUTHORS file
 */

/*
 * Copyright (C) 2012-2016 ULCO http://www.univ-littoral.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ARTIS_KERNEL_BUILDER_HPP
#define ARTIS_KERNEL_BUILDER_HPP

#include <boost/property_tree/ptree.hpp>
#include <boost/property_tree/json_parser.hpp>

#include <artis/kernel/AbstractCoupledModel.hpp>

#include <sstream>

namespace artis { namespace kernel {

template < typename T, typename U, typename V, typename W >
class Builder
{
public:
    Builder(const std::string& json)
    {
        std::stringstream ss;

        ss << json;
        boost::property_tree::read_json(ss, pt);
    }

    virtual ~Builder()
    { }

    artis::kernel::AbstractCoupledModel < T, U, V, W >* build()
    {
        return 0;
    }

private:
    boost::property_tree::ptree pt;
};

} }

#endif
